PIPE(2)

NAME
pipe - create descriptor pair for interprocess communication

SYNOPSIS
#include <unistd.h>
int
pipe(int *fildes);

DESCRIPTION
The pipe() function creates a pipe, which is an object allowing bidirectional data flow, and allocates a pair of file descriptors.

By convention, the first descriptor is normally used as the read end of the pipe, and the second is normally the write end, so that data written to fildes[1] appears on (i.e., can be read from) fildes[0]. This allows the output of one program to be sent to another program: the source's standard output is set up to be the write end of the pipe, and the sink's standard input is set up to be the read end of the pipe. The pipe itself persists until all its associated descriptors are closed.

A pipe that has had an end closed is considered widowed. Writing on such a pipe causes the writing process to receive a SIGPIPE signal. Widowing a pipe is the only way to deliver end-of-file to a reader: after the reader consumes any buffered data, reading a widowed pipe returns a zero count.

Pipes are really a special case of the socketpair(2) call and, in fact, are implemented as such in the system.

The bidirectional nature of this implementation of pipes is not portable to older systems, so it is recommended to use the convention for using the endpoints in the traditional manner when using a pipe in one direction.

RETURN VALUES
On successful creation of the pipe, zero is returned. Otherwise, a value of -1 is returned and the variable errno set to indicate the error.

ERRORS
The pipe() call will fail if:

[EMFILE]
    Too many descriptors are active.

[ENFILE]
    The system file table is full.

[EFAULT]
    The fildes buffer is in an invalid area of the process's address space.

SEE ALSO
sh(1), read(2), write(2), fork(2), socketpair(2)

HISTORY
A pipe function call appeared in Version 6 AT&T UNIX.

Bidirectional pipes were first used on Unix System V release 4.